/* --------------------------------------------------------------------------
--
-- dsbench/firebird/func_work.sql
--
-- Copyright (C) 2014-2015 Rajko Thon <rajko.thon@leitstern.de>
--                         Mathias Ball <meb@leitstern.de>
--
-- DSBench is free software: you can redistribute it and/or modify it
-- under the terms of the GNU Lesser General Public License as published
-- by the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- You must obey the GNU Lesser General Public License in all respects for
-- all of the code used.
--
-- DSBench is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-- FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
-- License for more details.
--
-------------------------------------------------------------------------- */

create procedure tpcb_func_p_work(
  i_branch_id         bigint,
  i_teller_id         bigint,
  i_account_id        bigint,
  i_delta             bigint
)
returns (
  o_account_balance   bigint
)
as
begin
--{
  -- Step 1: set new balance
  update tpcb_account
     set account_balance = account_balance + :i_delta
   where account_id = :i_account_id; 

  -- Step 2: get current balance
  select account_balance
    from tpcb_account
   where account_id = :i_account_id
    into :o_account_balance;
    
  -- Step 3: teller
  update tpcb_teller
     set teller_balance = teller_balance + :i_delta
   where teller_id = :i_teller_id; 

  -- Step 4: branch
  update tpcb_branch
     set branch_balance = branch_balance + :i_delta
   where branch_id = :i_branch_id; 

  -- Step 5: write log
  insert
    into tpcb_history 
         (
          teller_id,
          branch_id,
          account_id,
          delta,
          ta_time
         )    
  values (
          :i_teller_id,
          :i_branch_id,
          :i_account_id,
          :i_delta,
          current_timestamp
         );

  suspend;
--}  
end;
